searchNodes=[{"doc":"Riptide is a data first framework for building realtime applications. Riptide makes building snappy, realtime applications a breeze by letting you think purely in terms of your data and functionally about what should happen when it changes.","ref":"Riptide.html","title":"Riptide","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Riptide.html#child_spec/1","title":"Riptide.child_spec/1","type":"function"},{"doc":"Convience method to apply a mutation that deletes a single path Examples iex&gt; Riptide.delete([&quot;foo&quot;, &quot;bar&quot;]) {:ok, %{ delete: %{ &quot;foo&quot; =&gt; %{ &quot;bar&quot; =&gt; 1 } }, delete: %{} }}","ref":"Riptide.html#delete/2","title":"Riptide.delete/2","type":"function"},{"doc":"The same as delete/2 but raises an exception if it fails","ref":"Riptide.html#delete!/2","title":"Riptide.delete!/2","type":"function"},{"doc":"Convience method to apply a mutation that merges a single value Examples iex&gt; Riptide.merge([&quot;foo&quot;, &quot;bar&quot;], &quot;hello&quot;) {:ok, %{ merge: %{ &quot;foo&quot; =&gt; %{ &quot;bar&quot; =&gt; &quot;hello } }, delete: %{} }}","ref":"Riptide.html#merge/3","title":"Riptide.merge/3","type":"function"},{"doc":"The same as merge/3 but raises an exception if it fails","ref":"Riptide.html#merge!/3","title":"Riptide.merge!/3","type":"function"},{"doc":"Apply a mutation. This will do following steps in order Trigger Riptide.Interceptor.mutation_before/4 Trigger Riptide.Interceptor.mutation_effect/4 Broadcast mutation to interested processes Write mutation to stores Trigger Riptide.Interceptor.mutation_after/4 Examples iex&gt; mut = Riptide.Mutation.put_merge([&quot;foo&quot;, &quot;bar&quot;], &quot;hello&quot;) iex&gt; Riptide.mutation(mut) {:ok, %{ merge: %{ &quot;foo&quot; =&gt; %{ &quot;bar&quot; =&gt; &quot;hello } }, delete: %{} }}","ref":"Riptide.html#mutation/2","title":"Riptide.mutation/2","type":"function"},{"doc":"The same as mutation/2 but raises an exception if it fails","ref":"Riptide.html#mutation!/2","title":"Riptide.mutation!/2","type":"function"},{"doc":"Pass in a query and get the results. Read more about query structure here. State parameter is optional and is passed to interceptors. Options :min - Starting range of query, optional :max - End range of query, optional :limit - Max number of results, optional Examples iex&gt; Riptide.query(%{ &quot;todo:info&quot; =&gt; %{} }) %{ &quot;todo:info&quot; =&gt; %{ &quot;todo1&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;Document riptide&quot; } } }","ref":"Riptide.html#query/2","title":"Riptide.query/2","type":"function"},{"doc":"Return data under a specific path Options :min - Starting range of query, optional :max - End range of query, optional :limit - Max number of results, optional","ref":"Riptide.html#query_path/3","title":"Riptide.query_path/3","type":"function"},{"doc":"The same as query_path/3 but raises an exception if it fails","ref":"Riptide.html#query_path!/3","title":"Riptide.query_path!/3","type":"function"},{"doc":"Starts a Riptide process. Probably should not called this directly and instead should be placed inside your application&#39;s root supervisor. Options :port - Optional, will override default port of 12_000","ref":"Riptide.html#start_link/1","title":"Riptide.start_link/1","type":"function"},{"doc":"Return a stream of values underneath a path Options :min - Starting range of query, optional :max - End range of query, optional :limit - Max number of results, optional Examples iex&gt; Riptide.stream([&quot;todo:info&quot;]) |&gt; Enum.take(1) [ %{&quot;todo1&quot;, %{ &quot;text&quot; =&gt; &quot;Document riptide&quot; }} ]","ref":"Riptide.html#stream/3","title":"Riptide.stream/3","type":"function"},{"doc":"Riptide Interceptors let you define simple rules using Elixir&#39;s pattern matching that trigger conditionally when data is written or read. Each one is defined as a module that can be added to your Riptide configuration for easy enabling/disabling. config :riptide, interceptors: [ TodoList.Permissions, TodoList.Todo.Created, TodoList.Todo.Alert ] Every Interceptor in this list is called in order for every Mutation and Query processed Mutation Interceptors Mutation interceptors run as a mutation is being processed. The callbacks are called for each part of the paths in the mutation so you can define a pattern to match any kind of mutation. The arguments passed to them are path: A string list representing the path where the data is being written layer: The merge and delete that is occuring at the path mut: The full, original mutation state: The state of the connection which can be used to store things like the currently authed user mutation_before This runs before a mutation is written. It&#39;s best used to perform validations to make sure the data looks right, augmenting mutations with information that is known by the server only, or data denormalization. Here is an example that keeps track of the time when a Todo was marked complete defmodule Todo.Created do use Riptide.Interceptor def mutation_before([&quot;todos&quot;, _key], %{ merge: %{ &quot;complete&quot; =&gt; true }}, state) do { :merge, %{ &quot;times&quot; =&gt; %{ &quot;completed&quot; =&gt; :os.system_time(:millisecond) } } } end end The valid responses are :ok - Returns successfully but doesn&#39;t modify anything {:error, err} - Halts processing of interceptors and returns the error {:combine, mut} - Combines mut with the input mutation before writing {:merge, map} - Convenience version of :combine that merges map at the current path {:delete, map} - Convenience version of :combine that deletes map at the current path mutation_effect This interceptor can be used to schedule work to be done after a mutation is successfully written. It can be used to trigger side effects like sending an email or syncing data with a third party system. defmodule Todo.Created do use Riptide.Interceptor def mutation_before([&quot;todos&quot;, _key], %{ merge: %{ &quot;complete&quot; =&gt; true }}, state) do { :merge, %{ &quot;times&quot; =&gt; %{ &quot;completed&quot; =&gt; :os.system_time(:millisecond) } } } end end The valid responses are :ok - Returns successfully but doesn&#39;t schedule any work {fun, args} - Calls fun in the current module with args {module, fun, args} - Calls fun in module with args Query Interceptors Query interceptors run as a query is being processed. They can be used to allow/disallow access to certain paths or even expose third party data sources. Unlike the mutation interceptors they are called only once for each path requested by a query. The arguments passed to them are path: A string list representing the full path where the data is being written opts: The options for the query at this path state: The state of the connection which can be used to store things like the currently authed user query_before This runs before data is read. A common way to use it is to control access to data defmodule Todo.Permissions do use Riptide.Interceptor def query_before([&quot;secrets&quot; | _rest], _opts, state) do case state do state.user === &quot;bad-guy&quot; -&gt; {:error, :auth_error} true -&gt; :ok end end end The valid responses are :ok - Returns successfully {:error, err} - Halts processing of interceptors and returns the error query_resolve This is run before data is fetched from the store. This interceptor allows you to return data for the query and skip reading from the store. They effectively create virtual paths. defmodule Todo.Twilio do use Riptide.Interceptor def query_resolve([&quot;twilio&quot;, &quot;numbers&quot; | _rest], _opts, state) do TwilioApi.numbers() |&gt; case do {:ok, result} -&gt; Kernel.get_in(result, rest) {:error, err} -&gt; {:error, err} end end end The valid responses are nil - Skips this interceptor and continues processing any_value - Returns any_value as the data under the requested path","ref":"Riptide.Interceptor.html","title":"Riptide.Interceptor","type":"behaviour"},{"doc":"","ref":"Riptide.Interceptor.html#c:mutation_after/4","title":"Riptide.Interceptor.mutation_after/4","type":"callback"},{"doc":"Trigger mutation_before callback on configured interceptors for given mutation","ref":"Riptide.Interceptor.html#mutation_before/2","title":"Riptide.Interceptor.mutation_before/2","type":"function"},{"doc":"Trigger mutation_before callback on interceptors for given mutation","ref":"Riptide.Interceptor.html#mutation_before/3","title":"Riptide.Interceptor.mutation_before/3","type":"function"},{"doc":"","ref":"Riptide.Interceptor.html#c:mutation_before/4","title":"Riptide.Interceptor.mutation_before/4","type":"callback"},{"doc":"Trigger mutation_effect callback on configured interceptors for given mutation","ref":"Riptide.Interceptor.html#mutation_effect/2","title":"Riptide.Interceptor.mutation_effect/2","type":"function"},{"doc":"Trigger mutation_effect callback on interceptors for given mutation","ref":"Riptide.Interceptor.html#mutation_effect/3","title":"Riptide.Interceptor.mutation_effect/3","type":"function"},{"doc":"","ref":"Riptide.Interceptor.html#c:mutation_effect/4","title":"Riptide.Interceptor.mutation_effect/4","type":"callback"},{"doc":"Trigger query_before callback on configured interceptors for given query","ref":"Riptide.Interceptor.html#query_before/2","title":"Riptide.Interceptor.query_before/2","type":"function"},{"doc":"Trigger query_before callback on interceptors for given query","ref":"Riptide.Interceptor.html#query_before/3","title":"Riptide.Interceptor.query_before/3","type":"function"},{"doc":"","ref":"Riptide.Interceptor.html#c:query_before/3","title":"Riptide.Interceptor.query_before/3","type":"callback"},{"doc":"Trigger query_resolve callback on configured interceptors for given query","ref":"Riptide.Interceptor.html#query_resolve/2","title":"Riptide.Interceptor.query_resolve/2","type":"function"},{"doc":"Trigger query_resolve callback on interceptors for given query","ref":"Riptide.Interceptor.html#query_resolve/3","title":"Riptide.Interceptor.query_resolve/3","type":"function"},{"doc":"","ref":"Riptide.Interceptor.html#c:query_resolve/3","title":"Riptide.Interceptor.query_resolve/3","type":"callback"},{"doc":"A mutation represents a set of changes that can be applied to a Riptide.Store. This module contains functions that make it easy to compose complex mutations and combine them together. Mutations contains two types of operations: :merge - A map containing the values that will be merged in - creating them if they don&#39;t already exist :delete - A map containing the paths that should be deleted from the store Deleting In a mutation, the deletes are always applied first. They are expressed as a map with a value of 1 for each path to be deleted. iex&gt; Mutation.put_delete([&quot;todo:info&quot;, &quot;001&quot;]) %Riptide.Mutation{ delete: %{ &quot;todo:info&quot; =&gt; %{ &quot;001&quot; =&gt; 1 } }, merge: %{} } This mutation will delete everything under [&quot;todo:info&quot;, &quot;001] Merging Merges are applied after deletes and are expressed as a map pointing to the values that should be set. Mutation.put_merge( [&quot;todo:info&quot;, &quot;001&quot;], %{ &quot;key&quot; =&gt; &quot;001&quot;, &quot;text&quot; =&gt; &quot;Document riptide!&quot; } ) %Riptide.Mutation{ delete: %{}, merge: %{ &quot;todo:info&quot; =&gt; %{ &quot;001&quot; =&gt; %{ &quot;key&quot; =&gt; &quot;001&quot;, &quot;text&quot; =&gt; &quot;Document riptide!&quot; } } } } This mutation will delete everything under [&quot;todo:info&quot;, &quot;001] Composing There are various functions in this module for composing sophisticated mutations. A good approach is to break down a complex mutation into atomic pieces for clarity and combine them together. Here are some examples of how they can be helpful: Mutation.new() |&gt; Mutation.put_merge([&quot;user:info&quot;, &quot;001&quot;, &quot;name&quot;], &quot;jack&quot;) |&gt; Mutation.put_merge([&quot;user:info&quot;, &quot;002&quot;, &quot;name&quot;], &quot;john&quot;) |&gt; Mutation.put_delete([&quot;todo:info&quot;]) %Riptde.Mutation{ delete: %{&quot;todo:info&quot; =&gt; 1}, merge: %{ &quot;user:info&quot; =&gt; %{ &quot;001&quot; =&gt; %{&quot;name&quot; =&gt; &quot;jack&quot;}, &quot;002&quot; =&gt; %{&quot;name&quot; =&gt; &quot;john&quot;} } } } def create_user_mut(key, email) do Mutation.put_merge([&quot;user:info&quot;, key], %{ &quot;key&quot; =&gt; key, &quot;email&quot; =&gt; email }) end def set_password_mut(key, password) do Mutation.put_merge([&quot;user:passwords&quot;, key], Bcrypt.encrypt(password)) end Mutation.combine( create_user_mut(&quot;001&quot;, &quot;user@example.com&quot;), set_password_mut(&quot;001&quot;, &quot;mypassword&quot;) ) %Riptde.Mutation{ merge: %{ &quot;user:info&quot; =&gt; %{ &quot;001&quot; =&gt; %{ &quot;key&quot; =&gt; &quot;001&quot;, &quot;email&quot; =&gt; &quot;user@example.com&quot;, } }, &quot;user:password&quot; =&gt; %{ &quot;001&quot; =&gt; &quot;$2a$10$kj5ZhhLWIwik8uK4RJrDA.ddOEIK5VO9f4Y5FwL5D3CvVafSVXcYe&quot; } } } 1..100 |&gt; Stream.map(fn index -&gt; Mutation.merge([&quot;todo:info&quot;, to_string(index)], index) end) |&gt; Mutation.combine() %Riptide.Mutation{ delete: %{}, merge: %{ &quot;todo:info&quot; =&gt; %{ &quot;1&quot; =&gt; 1, &quot;2&quot; =&gt; 2, &quot;3&quot; =&gt; 3, ... } }","ref":"Riptide.Mutation.html","title":"Riptide.Mutation","type":"module"},{"doc":"Applies the entire mutation to the input map. Example iex&gt; Riptide.Mutation.apply( ...&gt; %{&quot;b&quot; =&gt; false}, ...&gt; %{delete: %{}, merge: %{&quot;a&quot; =&gt; true}} ...&gt; ) %{&quot;a&quot; =&gt; true, &quot;b&quot; =&gt; false}","ref":"Riptide.Mutation.html#apply/2","title":"Riptide.Mutation.apply/2","type":"function"},{"doc":"Takes a stream of mutations, combines them in batches of size count. Useful when writing a lot of mutations that would be faster written as batches. Examples iex&gt; 1..10 ...&gt; |&gt; Stream.map(fn index -&gt; Riptide.Mutation.put_merge([&quot;data&quot;, to_string(index)], index) end) ...&gt; |&gt; Riptide.Mutation.chunk(5) ...&gt; |&gt; Enum.to_list() [ %Riptide.Mutation{ delete: %{}, merge: %{&quot;data&quot; =&gt; %{&quot;1&quot; =&gt; 1, &quot;2&quot; =&gt; 2, &quot;3&quot; =&gt; 3, &quot;4&quot; =&gt; 4, &quot;5&quot; =&gt; 5}} }, %Riptide.Mutation{ delete: %{}, merge: %{&quot;data&quot; =&gt; %{&quot;10&quot; =&gt; 10, &quot;6&quot; =&gt; 6, &quot;7&quot; =&gt; 7, &quot;8&quot; =&gt; 8, &quot;9&quot; =&gt; 9}} } ]","ref":"Riptide.Mutation.html#chunk/2","title":"Riptide.Mutation.chunk/2","type":"function"},{"doc":"Takes a list or stream of Mutations and combines them in order to produce a single output mutation. Examples iex&gt; 0..3 ...&gt; |&gt; Stream.map(fn index -&gt; ...&gt; Riptide.Mutation.put_merge([&quot;todo:info&quot;, to_string(index)], index) ...&gt; end) ...&gt; |&gt; Riptide.Mutation.combine() %Riptide.Mutation{delete: %{}, merge: %{&quot;todo:info&quot; =&gt; %{&quot;0&quot; =&gt; 0, &quot;1&quot; =&gt; 1, &quot;2&quot; =&gt; 2, &quot;3&quot; =&gt; 3}}}","ref":"Riptide.Mutation.html#combine/1","title":"Riptide.Mutation.combine/1","type":"function"},{"doc":"Combines the right mutation into the left mutation and returns a singular mutation Examples iex&gt; Riptide.Mutation.combine( ...&gt; %Riptide.Mutation{delete: %{}, merge: %{&quot;a&quot; =&gt; true}}, ...&gt; %Riptide.Mutation{delete: %{}, merge: %{&quot;b&quot; =&gt; false}} ...&gt; ) %Riptide.Mutation{delete: %{}, merge: %{&quot;a&quot; =&gt; true, &quot;b&quot; =&gt; false}}","ref":"Riptide.Mutation.html#combine/2","title":"Riptide.Mutation.combine/2","type":"function"},{"doc":"Takes two maps and returns a mutation that could be applied to turn the the first map into the second. Examples iex&gt; Riptide.Mutation.diff( ...&gt; %{&quot;a&quot; =&gt; 1}, ...&gt; %{&quot;b&quot; =&gt; 2} ...&gt; ) %Riptide.Mutation{delete: %{&quot;a&quot; =&gt; 1}, merge: %{&quot;b&quot; =&gt; 2}}","ref":"Riptide.Mutation.html#diff/2","title":"Riptide.Mutation.diff/2","type":"function"},{"doc":"Accepts a list and mutation, and returns a new mutation with the given mutation nested at the given path. Example iex&gt; Riptide.Mutation.inflate( ...&gt; [&quot;a&quot;, &quot;b&quot;], ...&gt; %{ ...&gt; delete: %{}, ...&gt; merge: %{ ...&gt; &quot;a&quot; =&gt; 1 ...&gt; } ...&gt; } ...&gt; ) %Riptide.Mutation{ delete: %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; %{} } }, merge: %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; %{ &quot;a&quot; =&gt; 1 } } } }","ref":"Riptide.Mutation.html#inflate/2","title":"Riptide.Mutation.inflate/2","type":"function"},{"doc":"Returns a mapping with an entry for every layer of the mutation. The keys represent a path and the value represents the full mutation that is being merged in at that path. Examples iex&gt; Riptide.Mutation.put_merge([&quot;a&quot;, &quot;b&quot;], true) |&gt; Riptide.Mutation.layers %{ [] =&gt; %Riptide.Mutation{ delete: %{}, merge: %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; true } } }, [&quot;a&quot;] =&gt; %Riptide.Mutation{ delete: %{}, merge: %{ &quot;b&quot; =&gt; true } } }","ref":"Riptide.Mutation.html#layers/1","title":"Riptide.Mutation.layers/1","type":"function"},{"doc":"Creates a new mutation, optionally passing in a map for merges or deletes Examples iex&gt; Riptide.Mutation.new %Riptide.Mutation{delete: %{}, merge: %{}}","ref":"Riptide.Mutation.html#new/2","title":"Riptide.Mutation.new/2","type":"function"},{"doc":"Creates a new mutation and puts a path to be deleted","ref":"Riptide.Mutation.html#put_delete/1","title":"Riptide.Mutation.put_delete/1","type":"function"},{"doc":"Adds a delete path to the input mutation Examples iex&gt; Riptide.Mutation.new() ...&gt; |&gt; Riptide.Mutation.put_delete([&quot;c&quot;]) %Riptide.Mutation{delete: %{&quot;c&quot; =&gt; 1}, merge: %{}}","ref":"Riptide.Mutation.html#put_delete/2","title":"Riptide.Mutation.put_delete/2","type":"function"},{"doc":"Creates a new mutation and puts a value to be merged Examples iex&gt; Riptide.Mutation.put_merge([&quot;a&quot;, &quot;b&quot;], 1) %Riptide.Mutation{delete: %{}, merge: %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1}}}","ref":"Riptide.Mutation.html#put_merge/2","title":"Riptide.Mutation.put_merge/2","type":"function"},{"doc":"Adds a merge value to the input mutation Examples iex&gt; mutation = Riptide.Mutation.put_merge([&quot;a&quot;, &quot;b&quot;], 1) iex&gt; Riptide.Mutation.put_merge(mutation, [&quot;a&quot;, &quot;c&quot;], 2) %Riptide.Mutation{delete: %{}, merge: %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; 2}}}","ref":"Riptide.Mutation.html#put_merge/3","title":"Riptide.Mutation.put_merge/3","type":"function"},{"doc":"A key-value pair representing a layer of the mutation. The key is a list of strings representing the path to the current layer. The value is a mutation, representing any deeper sub-mutations.","ref":"Riptide.Mutation.html#t:layer/0","title":"Riptide.Mutation.layer/0","type":"type"},{"doc":"A map containing paths to be added (merge) and paths to be removed (delete).","ref":"Riptide.Mutation.html#t:t/0","title":"Riptide.Mutation.t/0","type":"type"},{"doc":"","ref":"Riptide.Schema.html","title":"Riptide.Schema","type":"module"},{"doc":"","ref":"Riptide.Schema.html#from_alias/1","title":"Riptide.Schema.from_alias/1","type":"function"},{"doc":"","ref":"Riptide.Schema.html#mod_opts/1","title":"Riptide.Schema.mod_opts/1","type":"function"},{"doc":"","ref":"Riptide.Schema.html#schema/1","title":"Riptide.Schema.schema/1","type":"macro"},{"doc":"","ref":"Riptide.Schema.html#validate_child/4","title":"Riptide.Schema.validate_child/4","type":"function"},{"doc":"","ref":"Riptide.Schema.html#validate_required/2","title":"Riptide.Schema.validate_required/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.Any.html","title":"Riptide.Schema.Type.Any","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.Any.html#validate/2","title":"Riptide.Schema.Type.Any.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.Boolean.html","title":"Riptide.Schema.Type.Boolean","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.Boolean.html#validate/2","title":"Riptide.Schema.Type.Boolean.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.Enum.html","title":"Riptide.Schema.Type.Enum","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.Enum.html#validate/2","title":"Riptide.Schema.Type.Enum.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.List.html","title":"Riptide.Schema.Type.List","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.List.html#validate/2","title":"Riptide.Schema.Type.List.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.Map.html","title":"Riptide.Schema.Type.Map","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.Map.html#validate/2","title":"Riptide.Schema.Type.Map.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.Number.html","title":"Riptide.Schema.Type.Number","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.Number.html#validate/2","title":"Riptide.Schema.Type.Number.validate/2","type":"function"},{"doc":"","ref":"Riptide.Schema.Type.String.html","title":"Riptide.Schema.Type.String","type":"module"},{"doc":"","ref":"Riptide.Schema.Type.String.html#validate/2","title":"Riptide.Schema.Type.String.validate/2","type":"function"},{"doc":"Riptide stores are where data can be written to and read from. This module provides a behavior that can be implemented to integrate any data store with Riptide. Regardless of the underlying store, Riptide consistently provides a tree data model The following stores are available out of the box. Visit their Riptide.Store.Composite Riptide.Store.LMDB Riptide.Store.Memory Riptide.Store.Multi Riptide.Store.Postgres Riptide.Store.Riptide Configuration Stores can be assigned via configuration. Riptide supports specifying different stores for reads and for writes although typically you will configure the same for both: config :riptide, store: %{ read: {Riptide.Store.MyStore, option1: &quot;test&quot;}, write: {Riptide.Store.MyStore, option1: &quot;test&quot;} }","ref":"Riptide.Store.html","title":"Riptide.Store","type":"behaviour"},{"doc":"Initialize all configured stores","ref":"Riptide.Store.html#init/0","title":"Riptide.Store.init/0","type":"function"},{"doc":"","ref":"Riptide.Store.html#c:init/1","title":"Riptide.Store.init/1","type":"callback"},{"doc":"Apply mutation to configured write store. Does not trigger interceptors.","ref":"Riptide.Store.html#mutation/1","title":"Riptide.Store.mutation/1","type":"function"},{"doc":"Apply mutation to specified store with opts. Does not trigger interceptors.","ref":"Riptide.Store.html#mutation/3","title":"Riptide.Store.mutation/3","type":"function"},{"doc":"","ref":"Riptide.Store.html#c:mutation/3","title":"Riptide.Store.mutation/3","type":"callback"},{"doc":"Processes query with configured read store. Does not trigger interceptors.","ref":"Riptide.Store.html#query/1","title":"Riptide.Store.query/1","type":"function"},{"doc":"","ref":"Riptide.Store.html#c:query/2","title":"Riptide.Store.query/2","type":"callback"},{"doc":"Processes query with specified store with opts. Does not trigger interceptors.","ref":"Riptide.Store.html#query/3","title":"Riptide.Store.query/3","type":"function"},{"doc":"Stream data from configured read store.","ref":"Riptide.Store.html#stream/2","title":"Riptide.Store.stream/2","type":"function"},{"doc":"Stream data from specified read store with opts.","ref":"Riptide.Store.html#stream/4","title":"Riptide.Store.stream/4","type":"function"},{"doc":"This module provides a macro to define a store that splits up the data tree between various other stores. It is implemented via pattern matching paths that are being written or read and specifying which store to go to. Usage defmodule Todolist.Store do use Riptide.Store.Composite @memory {Riptide.Store.Memory, []} @local {Riptide.Store.LMDB, directory: &quot;data&quot;} @shared {Riptide.Store.Postgres, []} def store(), do: [ @memory, @local, @shared, ] # Any path starting with [&quot;shared&quot;] is saved in a shared postgres instance def which_path([&quot;shared&quot; | _rest]), do: @shared # Any path starting with [&quot;tmp&quot;] is kept only in memory def which_path([&quot;tmp&quot; | _rest]), do: @memory # Default catch all def which_path(_), do: @local end Configuration config :riptide, store: %{ read: {Todolist.Store, []}, write: {Todolist.Store, []}, }","ref":"Riptide.Store.Composite.html","title":"Riptide.Store.Composite","type":"behaviour"},{"doc":"List of stores to initialize that are used by this module.","ref":"Riptide.Store.Composite.html#c:stores/0","title":"Riptide.Store.Composite.stores/0","type":"callback"},{"doc":"For a given path, return which store to use. Take advantage of pattern matching to specify broad areas.","ref":"Riptide.Store.Composite.html#c:which_store/1","title":"Riptide.Store.Composite.which_store/1","type":"callback"},{"doc":"This store persists data to LMDB using a bridge built in Rust. LMDB is a is a fast, memory mapped key value store that is persisted to a single file. It&#39;s a great choice for many projects that need persistence but want to avoid the overhead of setting up a standalone database. Configuration This store has a dependency on the Rust toolchain which can be installed via rustup. Once installed, add the bridge_lmdb dependency to your mix.exs. defp deps do [ {:riptide, &quot;~&gt; 0.4.0&quot;}, {:bridge_lmdb, &quot;~&gt; 0.1.1&quot;} ] end And then you can configure the store: config :riptide, store: %{ read: {Riptide.Store.LMDB, directory: &quot;data&quot;}, write: {Riptide.Store.LMDB, directory: &quot;data&quot;}, } Options :directory - directory where the database is stored (required)","ref":"Riptide.Store.LMDB.html","title":"Riptide.Store.LMDB","type":"module"},{"doc":"","ref":"Riptide.Store.LMDB.html#iterate/3","title":"Riptide.Store.LMDB.iterate/3","type":"function"},{"doc":"This store persists all data into an ETS table. It will not survive restarts and is best used for local development or in conjunction with Riptide.Store.Composite to keep a portion of the tree in memory. Configuration config :riptide, store: %{ read: {Riptide.Store.Memory, []}, write: {Riptide.Store.Memory, []}, } Options :table - name for ETS table, defaults to :riptide_table (optional)","ref":"Riptide.Store.Memory.html","title":"Riptide.Store.Memory","type":"module"},{"doc":"","ref":"Riptide.Store.Memory.html#snapshot_load/1","title":"Riptide.Store.Memory.snapshot_load/1","type":"function"},{"doc":"","ref":"Riptide.Store.Memory.html#snapshot_write/1","title":"Riptide.Store.Memory.snapshot_write/1","type":"function"},{"doc":"A proxy store that will write data to multiple stores. Configuration config :riptide, store: %{ read: {Riptide.Store.Memory, []}, write: {Riptide.Store.Multi, writes: [ {Riptide.Store.LMDB, directory: &quot;data&quot;}, {Riptide.Store.Memory, []} ]} } Options :stores - list of stores to write data to (required)","ref":"Riptide.Store.Multi.html","title":"Riptide.Store.Multi","type":"module"},{"doc":"","ref":"Riptide.Store.Next.SQL.html","title":"Riptide.Store.Next.SQL","type":"module"},{"doc":"","ref":"Riptide.Store.Next.SQL.html#new/1","title":"Riptide.Store.Next.SQL.new/1","type":"function"},{"doc":"","ref":"Riptide.Store.Next.SQL.html#select/2","title":"Riptide.Store.Next.SQL.select/2","type":"function"},{"doc":"","ref":"Riptide.Store.Next.SQL.html#to_sql/1","title":"Riptide.Store.Next.SQL.to_sql/1","type":"function"},{"doc":"","ref":"Riptide.Store.Next.SQL.html#where/2","title":"Riptide.Store.Next.SQL.where/2","type":"function"},{"doc":"","ref":"Riptide.Store.Next.SQL.html#where/3","title":"Riptide.Store.Next.SQL.where/3","type":"function"},{"doc":"This store persists data to a single Postgres table as materialized paths. It is best used in scenarios where your application will have multiple erlang nodes running that all need shared access to data. Note with this store Postgres is treated like a dumb key/value store and does not take advantage of any other Postgres capabilities. Configuration Add postgrex as a dependency to your mix.exs. defp deps do [ {:riptide, &quot;~&gt; 0.4.0&quot;}, {:postgrex, &quot;~&gt; 0.15.3&quot;} ] end And then you can configure the store: config :riptide, store: %{ read: {Riptide.Store.Postgres, []}, write: {Riptide.Store.Postgres, []}, } You can start up a named Postgrex pool manually but this module provides a convenient way for you to do that. Add this to your application.ex: children = [ {Riptide.Store.Postgres, [ hostname: &quot;localhost&quot;, database: &quot;riptide&quot;, username: &quot;postgres&quot;, password: &quot;postgres&quot;, ]}, Riptide, ] opts = [strategy: :one_for_one, name: Riptide.Supervisor] Supervisor.start_link(children, opts) Note, make sure the Postgres pool starts up before Riptide. Options :table - name of table defaults to riptide (optional) :name - name of Postgrex pool, defaults to postgres (optional) :transaction_timeout - duration for transaction timeout in milliseconds, defaults to 1 minute (optional)","ref":"Riptide.Store.Postgres.html","title":"Riptide.Store.Postgres","type":"module"},{"doc":"Convenience implementation of Supervisor.child_spec/1 to start up a Postgrex pool with name :postgres Examples children = [ {Riptide.Store.Postgres, [ hostname: &quot;localhost&quot;, database: &quot;riptide&quot;, username: &quot;postgres&quot;, password: &quot;postgres&quot;, ]}, Riptide, ] opts = [strategy: :one_for_one, name: Riptide.Supervisor] Supervisor.start_link(children, opts)","ref":"Riptide.Store.Postgres.html#child_spec/1","title":"Riptide.Store.Postgres.child_spec/1","type":"function"},{"doc":"This store forwards all mutations and queries to another Riptide instance. This is useful if you have multiple Riptide instances but want all of them to write and read from a primary node. This is comparable to web applications that write to a centralized Postgres database. Used in conjuction with Riptide.Store.Composite will allow you to store some data globally and some data locally. Configuration A primary node will only accept connections from nodes configured with the same token. In your primary node be sure to set the following configuration with a random token: config :riptide, %{ store: %{ token: &quot;mytoken&quot; } } In your child node add the following configuration: config :riptide, %{ store: %{ read: {Riptide.Store.Riptide, []}, write: {Riptide.Store.Riptide, []}, } } Additionally in the child nodes setup a connection to the primary node in your application.ex: children = [ {Riptide.Store.Riptide, [ url: &quot;https://primary-node:12000/socket&quot;, name: :riptide, token: &quot;mytoken&quot; ]}, Riptide, ] This will startup a connection to the primary node before starting up Riptide locally. All data now will be written to and read from the primary node. Options :name - name of connection to primary node, defaults to :riptide (optional)","ref":"Riptide.Store.Riptide.html","title":"Riptide.Store.Riptide","type":"module"},{"doc":"Starts a connection to a remote Riptide instance Options :name - name of connection :url - url of remote node (required) :token - authorization token (required)","ref":"Riptide.Store.Riptide.html#child_spec/1","title":"Riptide.Store.Riptide.child_spec/1","type":"function"},{"doc":"","ref":"Riptide.Store.Riptide.html#opts_name/1","title":"Riptide.Store.Riptide.opts_name/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html","title":"Riptide.Store.SQL","type":"module"},{"doc":"","ref":"Riptide.Store.SQL.html#columns/2","title":"Riptide.Store.SQL.columns/2","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#delete/1","title":"Riptide.Store.SQL.delete/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#new/1","title":"Riptide.Store.SQL.new/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#select/1","title":"Riptide.Store.SQL.select/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#set/2","title":"Riptide.Store.SQL.set/2","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#to_sql/1","title":"Riptide.Store.SQL.to_sql/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#update/1","title":"Riptide.Store.SQL.update/1","type":"function"},{"doc":"","ref":"Riptide.Store.SQL.html#where/2","title":"Riptide.Store.SQL.where/2","type":"function"},{"doc":"","ref":"Riptide.Store.Structure.html","title":"Riptide.Store.Structure","type":"module"},{"doc":"","ref":"Riptide.Store.Structure.html#structure/3","title":"Riptide.Store.Structure.structure/3","type":"macro"},{"doc":"","ref":"Riptide.Store.TreeLMDB.html","title":"Riptide.Store.TreeLMDB","type":"module"},{"doc":"","ref":"Riptide.Store.TreeLMDB.html#iterate/3","title":"Riptide.Store.TreeLMDB.iterate/3","type":"function"},{"doc":"","ref":"Riptide.Store.TreePostgres.html","title":"Riptide.Store.TreePostgres","type":"module"},{"doc":"","ref":"Riptide.Store.TreePostgres.html#delete/3","title":"Riptide.Store.TreePostgres.delete/3","type":"function"},{"doc":"","ref":"Riptide.Store.TreePostgres.html#do_zip/2","title":"Riptide.Store.TreePostgres.do_zip/2","type":"function"},{"doc":"","ref":"Riptide.Store.TreePostgres.html#merge/3","title":"Riptide.Store.TreePostgres.merge/3","type":"function"},{"doc":"","ref":"Riptide.Store.TreePostgres.html#zip/2","title":"Riptide.Store.TreePostgres.zip/2","type":"function"},{"doc":"","ref":"Riptide.Tree.html","title":"Riptide.Tree","type":"module"},{"doc":"","ref":"Riptide.Tree.html#branch/2","title":"Riptide.Tree.branch/2","type":"macro"},{"doc":"","ref":"Riptide.Tree.Branch.html","title":"Riptide.Tree.Branch","type":"module"},{"doc":"This module allows you to generate sortable Time UUIDs that can be used to control sorting order in Riptide stores. They have a time component that defaults to creation time as well as a random component. Ascending UUIDs generated with Riptide.UUID.ascending/0 will be sorted oldest to newest by their time component. Descending UUIDs generated with Riptide.UUID.descending/0 will be sorted newest to oldest by their time component. Usage Take the following data: { &quot;todo:info&quot;: { &quot;0S1eOQ0kd0wnuUSWbDAu&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My first todo!&quot; } } } This entry uses an ascending UUID. This means if we create a new entry with an ascending UUID it will be inserted below the existing entry: { &quot;todo:info&quot;: { &quot;0S1eOQ0kd0wnuUSWbDAu&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My first todo!&quot; }, &quot;0S1eP9y9x61XmeVoHzVM&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My second todo!&quot; } } } Now let&#39;s try it with descending UUIDs: { &quot;todo:info&quot;: { &quot;zXyLafLmMB6Uac8NTOvA&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My first todo!&quot; } } } Adding another todo will insert it above the existing entry: { &quot;todo:info&quot;: { &quot;zXyLaUMUDcB4zaVNCLM2&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My second todo!&quot; }, &quot;zXyLafLmMB6Uac8NTOvA&quot; =&gt; %{ &quot;text&quot; =&gt; &quot;My first todo!&quot; } } } The type of UUID that should be used depends on how your application is planning on using the data. For example, if your application typically loads the 10 newest created todos it makes sense to use descending UUIDs with the following query: Riptide.query_path [&quot;todo:info&quot;], %{limit: 10} Explore the functions in this module to see the additional options there are for creating UUIDs.","ref":"Riptide.UUID.html","title":"Riptide.UUID","type":"module"},{"doc":"Generate a UUID that can be sorted lexicographically from oldest to newest. The time component is set to the current time.","ref":"Riptide.UUID.html#ascending/0","title":"Riptide.UUID.ascending/0","type":"function"},{"doc":"Like ascending/1 with the ability to specify time component.","ref":"Riptide.UUID.html#ascending/1","title":"Riptide.UUID.ascending/1","type":"function"},{"doc":"For a given ascending UUID, extract the time component in milliseconds.","ref":"Riptide.UUID.html#ascending_decode_time/1","title":"Riptide.UUID.ascending_decode_time/1","type":"function"},{"doc":"Like ascending/1 with the ability to specify time component.","ref":"Riptide.UUID.html#ascending_uniform/1","title":"Riptide.UUID.ascending_uniform/1","type":"function"},{"doc":"Generate a UUID that can be sorted lexicographically from newest to oldest. The time component is set to the current time.","ref":"Riptide.UUID.html#descending/0","title":"Riptide.UUID.descending/0","type":"function"},{"doc":"Like descending/0 with the ability to specify time component in milliseconds.","ref":"Riptide.UUID.html#descending/1","title":"Riptide.UUID.descending/1","type":"function"},{"doc":"For a given descending UUID, extract the time component in milliseconds.","ref":"Riptide.UUID.html#descending_decode_time/1","title":"Riptide.UUID.descending_decode_time/1","type":"function"},{"doc":"Like descending/1 with the random part zero filled. Useful for specifying ranges of UUIDs in queries.","ref":"Riptide.UUID.html#descending_uniform/1","title":"Riptide.UUID.descending_uniform/1","type":"function"},{"doc":"Overview Riptide is a data first framework for building realtime applications. Riptide makes building snappy, realtime applications a breeze by letting you think purely in terms of your data and functionally about what should happen when it changes. Build your first Riptide application.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Traditional frameworks require you to think about your data in numerous ways: Objects in your application Relational tables in your database Events in your message queue Riptide represents all of your data as one big tree no matter where you are: server, client or database { &quot;users&quot;: { &quot;USR1&quot;: { &quot;key&quot;: &quot;USR1&quot;, &quot;name&quot;: &quot;Jack Sparrow&quot;, }, &quot;USR2&quot;: {...}, &quot;USR3&quot;: {...} }, &quot;todos&quot;: { &quot;TOD1&quot;: { &quot;key&quot;: &quot;TOD1&quot;, &quot;user&quot;: &quot;USR1&quot;, &quot;created&quot;: 1586068269822, &quot;text&quot;: &quot;Find the Black Pearl&quot;, } ... } } Take a deep dive into Mutations, Queries, and Stores","ref":"overview.html#one-data-model-everywhere","title":"Overview - One data model — everywhere","type":"extras"},{"doc":"Riptide Interceptors let you define simple rules using Elixir&#39;s pattern matching that trigger conditionally when data is written or read. Take the following Mutation that creates a new Todo. { &quot;merge&quot;: { &quot;todos&quot;: { &quot;TOD2&quot;: { &quot;key&quot;: &quot;TOD2&quot;, &quot;text&quot;: &quot;Return cursed Aztec gold&quot; } } } } It will trigger the following Interceptor which effectively says whenever a Todo is created, record the current time and user who created it. defmodule Todo.Created do use Riptide.Interceptor def before_mutation( # Match path being written to [&quot;todos&quot;, _key], # Match fields being merged %{ merge: %{ &quot;key&quot; =&gt; _ }}, # Full mutation _full, # Connection state state ) do { :merge, %{ &quot;created&quot; =&gt; :os.system_time(:millisecond), &quot;user&quot; =&gt; state.user } } end end This results in the following data being written { &quot;todos&quot;: { &quot;TOD2&quot;: { &quot;key&quot;: &quot;TOD2&quot;, &quot;text&quot;: &quot;Return cursed Aztec gold&quot;, &quot;created&quot;: 1586068269822, &quot;user&quot;: &quot;USR1&quot; } } } Interceptors are simple but powerful. Even the most complex business logic can be broken down into a collection of composable, independent and easily digestable Interceptors. Learn more about the various interceptors available in Riptide","ref":"overview.html#composable-logic","title":"Overview - Composable logic","type":"extras"},{"doc":"Riptide takes care of shipping data around and ensuring all observers are kept up to date with the latest changes. This happens automatically - there&#39;s no pub/sub system to setup or event triggers and handlers to define. // React example Riptide.remote.query_path([&quot;todos&quot;], { subscribe: true }) function render() { return ( &lt;ul&gt; { Riptide.local .query_values([&quot;todos&quot;]) .map(item =&gt; ( &lt;li key={item.key}&gt;{item.text}&lt;/li&gt; )) } &lt;/ul&gt;; ) } Instead of being an after thought, 100% of the UIs you build will be realtime by default.","ref":"overview.html#realtime-by-default","title":"Overview - Realtime by default","type":"extras"},{"doc":"Getting Started This guide is an intro to Riptide, the data first framework for building realtime applications in Elixir. In this guide we will learn how to setup a basic Riptide application and go over how to use its tools like queries, mutations, interceptors and more","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"To start off we&#39;ll generate a new Elixir application - skip this step if you already have one. mix new todolist --sup mkdir ./todolist/config echo &quot;use Mix.Config&quot; &gt; ./todolist/config/config.exs The --sup ensures the application has a root supervision tree which we&#39;ll need to initialize and manage Riptide. Riptide relies on configuration so we also create a config.exs file for your application. We will need to add Riptide as a dependency. Go to your mix.exs file and update the deps: defp deps do [ {:riptide, &quot;~&gt; 0.4.0&quot;}, ] end Then install the dependency by running: mix deps.get Now that we have the dependency installed we can add it to our application. Go to your lib/todolist/application.ex and Riptide within the application&#39;s supervision tree: def start(_type, _args) do children = [ Riptide ] ... That&#39;s it! You now have a barebones Riptide app ready to go. Start up the server by running: iex -S mix This will give you a running shell into your application. Let&#39;s test it out by saving some data and pulling it back out: iex&gt; Riptide.merge! [&quot;foo&quot;, &quot;bar&quot;], &quot;hello world&quot; %Riptide.Mutation{delete: %{}, merge: %{&quot;foo&quot; =&gt; %{&quot;bar&quot; =&gt; &quot;hello!&quot;}}} iex&gt; Riptide.query_path! [&quot;foo&quot;] %{&quot;bar&quot; =&gt; &quot;hello!&quot;} Before we continue let&#39;s learn a bit more about the Riptide data model","ref":"getting-started.html#adding-riptide-to-an-application","title":"Getting Started - Adding Riptide to an application","type":"extras"},{"doc":"Before diving into building a full application, it&#39;s important to understand the data model provided by Riptide. Riptide can be configured to store it&#39;s data in various backends but always gives a consistent structure across them all. You can think of Riptide&#39;s data model as a giant JSON tree. Here&#39;s an example of what it can look like: { &quot;user:info&quot;: { &quot;USRzXyccEPE3Mhg962H7lBS&quot;: { &quot;id&quot;: &quot;USRzXyccEPE3Mhg962H7lBS&quot;, &quot;name&quot;: &quot;Jack Sparrow&quot; } ... }, &quot;user:todos&quot;: { &quot;USRzXyccEPE3Mhg962H7lBS&quot;: { &quot;TODzXycc3dwxU1Il2D7hN3M&quot;: { &quot;id&quot;: &quot;TODzXycc3dwxU1Il2D7hN3M&quot;, &quot;text&quot;: &quot;Capture the black pearl!&quot; } ... } } } Here are its properties Data can be merged anywhere in the tree. Any part of the tree and all its children can be deleted All data under every node of a tree is sorted by ascending order The tree can be queried to return either all or a range of data under a path When working with the data model we will often talk about paths, which is similar to a directory path. They&#39;re represented as a list of strings that point to a part of the tree. In the above example the path [&quot;user:info&quot;, &quot;USRzXyccEPE3Mhg962H7lBS&quot;] would point to: { &quot;id&quot;: &quot;USRzXyccEPE3Mhg962H7lBS&quot;, &quot;name&quot;: &quot;Jack Sparrow&quot; } The path [&quot;user:todos&quot;, &quot;USRzXyccEPE3Mhg962H7lBS&quot;, &quot;TODzXycc3dwxU1Il2D7hN3M&quot;, &quot;text&quot;] would point to: &quot;Capture the black pearl!&quot; And that&#39;s it! At first this may seem primitive compared to what relational databases offer but you will see how through the tools provided by Riptide you can implement everything a modern application requires. Additionally, representing data across the entire application, (frontend, backend, over the wire) is simple. The tree can easily be modeled with any programming language using built-in data structures (hashmaps, objects, dictionaries) or data formats (JSON).","ref":"getting-started.html#the-tree-data-model","title":"Getting Started - The tree data model","type":"extras"},{"doc":"To update the tree, you must create a Riptide.Mutation. It contains paths and values to merge in and/or and paths to delete. To learn how to compose complex mutations read the full documentation here. Let&#39;s create a new Todo module that will contain helper functions to help us generate mutations. defmodule Todolist.Todo do def create(user_id, todo_id, text) do Riptide.Mutation.put_merge([&quot;user:todos&quot;, user_id, todo_id], %{ &quot;id&quot; =&gt; todo_id, &quot;text&quot; =&gt; text }) end def set_done(user_id, todo_id, bool), do: Riptide.Mutation.put_merge( [&quot;user:todos&quot;, user_id, todo_id, &quot;done&quot;], bool ) def delete(user_id, todo_id), do: Riptide.Mutation.put_delete([&quot;user:todos&quot;, user_id, todo_id]) end We&#39;ve created three functions create/3 - this returns a mutation that will insert a new todo under the specified user set_done/3 - this will update the done property of an existing todo delete/2 - this will delete an existing todo Remember, calling these functions won&#39;t actually write any data. They will only return a mutation that must then be written to your store: Todo.create( &quot;USRzXyccEPE3Mhg962H7lBS&quot;, &quot;TOD&quot; &lt;&gt; Riptide.UUID.descending(), &quot;My new todo!&quot;, ) |&gt; Riptide.mutation!() You can view the documentation for the Riptide.UUID module - it contains useful functions to generate sortable UUIDs which work well with Riptide&#39;s sorted tree data model. We recommend prefixing all of your UUIDs for legibility. Here is another example of creating a todo and marking it done in one transaction. todo_id = &quot;TOD&quot; &lt;&gt; Riptide.UUID.descending() user_id = &quot;USRzXyccEPE3Mhg962H7lBS&quot; Riptide.Mutation.combine([ Todo.create(user_id, todo_id, &quot;My new todo!&quot;), Todo.set_done(user_id, todo_id, true), ]) |&gt; Riptide.mutation!()","ref":"getting-started.html#updating-the-tree","title":"Getting Started - Updating the tree","type":"extras"},{"doc":"","ref":"getting-started.html#reading-from-the-tree","title":"Getting Started - Reading from the tree","type":"extras"}]